(function(){function r(e,n,t){function o(i,f){if(!n[i]){if(!e[i]){var c="function"==typeof require&&require;if(!f&&c)return c(i,!0);if(u)return u(i,!0);var a=new Error("Cannot find module '"+i+"'");throw a.code="MODULE_NOT_FOUND",a}var p=n[i]={exports:{}};e[i][0].call(p.exports,function(r){var n=e[i][1][r];return o(n||r)},p,p.exports,r,e,n,t)}return n[i].exports}for(var u="function"==typeof require&&require,i=0;i<t.length;i++)o(t[i]);return o}return r})()({1:[function(require,module,exports){
/**
* @realeyes/environment-checker version: 3.1.18
* Built on: 2021-07-30T13:40:45.913Z
* Released under the Apache-2.0 license
* @copyright Realeyes OU. All rights reserved.
* 
**/
"use strict";

function _typeof2(obj) { if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof2 = function _typeof2(obj) { return typeof obj; }; } else { _typeof2 = function _typeof2(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof2(obj); }

exports.__esModule = true;
exports["default"] = void 0;

var _environmentDetector = _interopRequireDefault(require("@realeyes/environment-detector"));

var _browsers = _interopRequireDefault(require("@realeyes/environment-detector/lib/browsers"));

var _os = _interopRequireDefault(require("@realeyes/environment-detector/lib/os"));

var _platform = _interopRequireDefault(require("@realeyes/environment-detector/lib/platform"));

var _Logger = _interopRequireDefault(require("@realeyes/environment-detector/lib/utils/Logger"));

var _v = _interopRequireDefault(require("uuid/v4"));

var _package = require("./package.json");

function _interopRequireDefault(obj) {
  return obj && obj.__esModule ? obj : {
    "default": obj
  };
}

function _typeof(obj) {
  if (typeof Symbol === "function" && _typeof2(Symbol.iterator) === "symbol") {
    _typeof = function _typeof(obj) {
      return _typeof2(obj);
    };
  } else {
    _typeof = function _typeof(obj) {
      return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : _typeof2(obj);
    };
  }

  return _typeof(obj);
}
/**
 * @typedef {{
 *   checksPassed: boolean,
 *   failureReasonCode: number,
 *   failureReasonString: string,
 *   detectorResult: EnvironmentDetectionResult,
 * }} EnvironmentCheckResult
 */


window.Realeyesit = window.Realeyesit || {};
window.Realeyesit.EnvironmentalDetectionAPI = {
  VERSION: _package.version,
  BLACKLISTED_BROWSERS: [[_browsers["default"].names.INTERNET_EXPLORER, '0-11'], [_browsers["default"].names.FIREFOX, '0-67'], [_browsers["default"].names.OPERA, '0-59'], [_browsers["default"].names.CHROME, '0-70'], [_browsers["default"].names.MICROSOFT_EDGE, '0-17'], [_browsers["default"].names.SAFARI, '0-11'], [_browsers["default"].names.UC_BROWSER, '0-100']],
  BLACKLISTED_OS: [],
  checkResults: {
    checksPassed: null,
    failureReasonCode: null,
    failureReasonString: null
  },
  failureReasonCodes: {
    BROWSER_NOT_CAPABLE: 4,
    MOBILE_BROWSER: 5,
    NO_WEBCAMS_DETECTED: 6,
    OTHER_ERROR: 7,
    IOS_WEBVIEW: 8,
    UNSUPPORTED_BROWSER: 9,
    //Browser is not supported, even not blacklisted for example exotic browsers
    TABLET_BROWSER: 10,
    DESKTOP_BROWSER: 11,
    BLACKLISTED: 12
  },

  /**
   * Filter non accepted options, transform some options to expected format
   * @param {Object} options non sanitized options
   * @return {Object} sanitized options
   */
  sanitizeOptions: function sanitizeOptions(options) {
    var sanitizedOptions = {};

    if (typeof options.allowedDevices !== 'undefined') {
      if (typeof options.allowedDevices === 'string') {
        try {
          sanitizedOptions.allowedDevices = JSON.parse(options.allowedDevices);
        } catch (e) {
          sanitizedOptions.allowedDevices = [];
        }
      } else {
        if (options.allowedDevices.constructor === Array) {
          // if browser does not support these methods it will not pass the EC check anyway...
          if (Array.prototype.filter && Object.values) {
            // filter out any non expected value, only platform.types allowed
            sanitizedOptions.allowedDevices = options.allowedDevices.filter(function (i) {
              return Object.values(_platform["default"].types).indexOf(i) >= 0;
            });
          } else {
            sanitizedOptions.allowedDevices = [];
          }
        }
      }
    }

    if (typeof options.isTablet !== 'undefined') {
      sanitizedOptions.isTablet = !!options.isTablet;
    }

    if (typeof options.isMobile !== 'undefined') {
      sanitizedOptions.isMobile = !!options.isMobile;
    }

    return sanitizedOptions;
  },

  /**
   * Merges default with options (shallow copy only!)
   * @param {Object} defaults Values for options
   * @param {Object} options Current options
   * @returns {Object} Merged options
   */
  mergeOptionsWithDefaults: function mergeOptionsWithDefaults(defaults, options) {
    for (var key in defaults) {
      if (defaults.hasOwnProperty(key) && typeof options[key] === 'undefined') {
        options[key] = defaults[key];
      }
    }

    return options;
  },

  /**
   * Transcribes options to handle deprecated options
   * @param {Object} options the original options
   * @return {Object} options the transcribed options
   */
  handleDeprecatedOptions: function handleDeprecatedOptions(options) {
    var allowedDevices = {};

    for (var i = 0; i < options.allowedDevices.length; i++) {
      allowedDevices[options.allowedDevices[i]] = true;
    }

    if (options.isMobile !== undefined) {
      allowedDevices[_platform["default"].types.MOBILE] = !!options.isMobile;
    }

    if (options.isTablet !== undefined) {
      allowedDevices[_platform["default"].types.TABLET] = !!options.isTablet;
    }

    options.allowedDevices = [];

    for (var key in allowedDevices) {
      if (allowedDevices.hasOwnProperty(key) && allowedDevices[key] === true) {
        options.allowedDevices.push(key);
      }
    }

    return options;
  },

  /**
   * Performs a list of checks and calls the callback with the checkResults object.
   *
   * @param {function({EnvironmentCheckResult})} callback Callback function
   * @param {*} options detection options
   * @param {*} logger Logging options
   * @return {undefined}
   */
  start: function start(callback) {
    var _this = this;

    var options = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {};

    var _ref = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : {},
        _ref$logger = _ref.logger,
        logger = _ref$logger === void 0 ? {} : _ref$logger,
        _ref$detect = _ref.detect,
        detect = _ref$detect === void 0 ? _environmentDetector["default"] : _ref$detect;

    var defaults = {
      allowedDevices: [_platform["default"].types.MOBILE, _platform["default"].types.TABLET, _platform["default"].types.DESKTOP]
    };
    options = this.sanitizeOptions(options);
    options = this.mergeOptionsWithDefaults(defaults, options);
    options = this.handleDeprecatedOptions(options);
    var loggerOpts = {
      disable: logger.disable,
      sid: (0, _v["default"])()
    };
    var ecLogger = new _Logger["default"](loggerOpts);
    ecLogger.log('environment-checker started', {
      version: this.VERSION
    });
    this.clearResults();
    this.checkResults.checksPassed = false;
    var detectorOptions = {
      logger: loggerOpts
    };
    ecLogger.log('environment-checker calling detector', detectorOptions);
    detect(detectorOptions).then(function (result) {
      ecLogger.log('environment-checker received detection result', result);

      if (!_this.checkBrowser(result)) {
        _this.checkResults.failureReasonCode = _this.failureReasonCodes.BROWSER_NOT_CAPABLE;
        _this.checkResults.failureReasonString = 'BROWSER_NOT_CAPABLE';
      } else if (result.browser.name === _browsers["default"].names.BLACKLISTED) {
        _this.checkResults.failureReasonCode = _this.failureReasonCodes.BLACKLISTED;
        _this.checkResults.failureReasonString = 'BLACKLISTED';
      } else if (result.browser.name === _browsers["default"].names.IOS_WEBVIEW) {
        _this.checkResults.failureReasonCode = _this.failureReasonCodes.IOS_WEBVIEW;
        _this.checkResults.failureReasonString = 'IOS_WEBVIEW';
      } else if (result.platform.type === _platform["default"].types.MOBILE && options.allowedDevices.indexOf(_platform["default"].types.MOBILE) === -1) {
        _this.checkResults.failureReasonCode = _this.failureReasonCodes.MOBILE_BROWSER;
        _this.checkResults.failureReasonString = 'MOBILE_BROWSER';
      } else if (result.platform.type === _platform["default"].types.TABLET && options.allowedDevices.indexOf(_platform["default"].types.TABLET) === -1) {
        _this.checkResults.failureReasonCode = _this.failureReasonCodes.TABLET_BROWSER;
        _this.checkResults.failureReasonString = 'TABLET_BROWSER';
      } else if (result.platform.type === _platform["default"].types.DESKTOP && options.allowedDevices.indexOf(_platform["default"].types.DESKTOP) === -1) {
        _this.checkResults.failureReasonCode = _this.failureReasonCodes.DESKTOP_BROWSER;
        _this.checkResults.failureReasonString = 'DESKTOP_BROWSER';
      } else if (result.webcams.length === 0) {
        _this.checkResults.failureReasonCode = _this.failureReasonCodes.NO_WEBCAMS_DETECTED;
        _this.checkResults.failureReasonString = 'NO_WEBCAMS_DETECTED';
      } else if (_this.unsupportedBrowser(result)) {
        _this.checkResults.failureReasonCode = _this.failureReasonCodes.UNSUPPORTED_BROWSER;
        _this.checkResults.failureReasonString = 'UNSUPPORTED_BROWSER';
        _this.checkResults.checksPassed = true;
      } else {
        _this.checkResults.checksPassed = true;
      }

      if (!_this.checkOS(result)) {
        _this.checkResults.failureReasonCode = _this.failureReasonCodes.MOBILE_BROWSER;
        _this.checkResults.failureReasonString = 'MOBILE_BROWSER';
        _this.checkResults.checksPassed = false;
      }

      _this.checkResults.detectorResult = result;
      ecLogger.log('environment-checker result', _this.checkResults);
      return callback(_this.checkResults);
    }, function (err) {
      _this.checkResults.failureReasonCode = _this.failureReasonCodes.OTHER_ERROR;
      _this.checkResults.failureReasonString = err.message;
      ecLogger.log('environment-checker error', err);
      return callback(_this.checkResults);
    });
  },

  /**
   * Checks if browser is capable for DC1 recording.
   *
   * @param {EnvironmentDetectionResult} res Environment check result
   * @return {boolean}
   */
  checkBrowser: function checkBrowser(res) {
    for (var i = 0; i < this.BLACKLISTED_BROWSERS.length; i++) {
      var name = this.BLACKLISTED_BROWSERS[i][0];
      var blacklistedVersions = this.BLACKLISTED_BROWSERS[i][1].split('-');
      var _ref2 = [parseInt(blacklistedVersions[0], 10), parseInt(blacklistedVersions[1], 10)],
          from = _ref2[0],
          to = _ref2[1];
      var browserVersion = parseInt(res.browser.version, 10);

      if (name === res.browser.name && browserVersion >= from && browserVersion <= to) {
        return false;
      }
    }

    return true;
  },

  /**
   * Checks if OS is capable for DC recording.
   *
   * @param {EnvironmentDetectionResult} res Environment check result
   * @return {boolean}
   */
  checkOS: function checkOS(res) {
    var isOsOK = true;
    this.BLACKLISTED_OS.forEach(function (blos) {
      if (blos.includes(res.os.name) && blos.includes(res.os.version)) {
        isOsOK = false;
      }
    });
    return isOsOK;
  },

  /**
   * Checks if browser is unsupported.
   *
   * @param {EnvironmentDetectionResult} res Environment check result
   * @return {boolean}
   */
  unsupportedBrowser: function unsupportedBrowser(res) {
    for (var i = 0; i < this.BLACKLISTED_BROWSERS.length; i++) {
      var name = this.BLACKLISTED_BROWSERS[i][0];

      if (name === res.browser.name) {
        return false;
      }
    }

    return true;
  },

  /**
   * Resets the checkResults object.
   *
   * @return {undefined}
   */
  clearResults: function clearResults() {
    this.checkResults = {
      checksPassed: null,
      failureReasonCode: null,
      failureReasonString: null
    };
  }
};
/* eslint-disable */

/**
 * Start detection immediately when window has a env detect callback.
 */

(function () {
  if (_typeof(window._RealeyesitEnvDetectParams) === 'object' && typeof window._RealeyesitEnvDetectParams._callback === 'function') {
    window.Realeyesit.EnvironmentalDetectionAPI.start(window._RealeyesitEnvDetectParams._callback, window._RealeyesitEnvDetectParams._options);
  } else {
    if (typeof window._RealeyesitEnvDetectCallback === 'function') {
      window.Realeyesit.EnvironmentalDetectionAPI.start(window._RealeyesitEnvDetectCallback, (window._RealeyesitEnvDetectParams || {})._options);
    }
  }
})();
/* eslint-enable */


var _default = window.Realeyesit.EnvironmentalDetectionAPI;
exports["default"] = _default;

},{"./package.json":18,"@realeyes/environment-detector":4,"@realeyes/environment-detector/lib/browsers":2,"@realeyes/environment-detector/lib/os":5,"@realeyes/environment-detector/lib/platform":6,"@realeyes/environment-detector/lib/utils/Logger":7,"uuid/v4":17}],2:[function(require,module,exports){
"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _getFirstMatch = _interopRequireDefault(require("./utils/getFirstMatch"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

/**
 * Browser detection.
 *
 * @copyright Realeyes OU. All rights reserved.
 */

/**
 * Enum for the browsers that we can detect.
 *
 * @enum {string}
 */
var names = {
  OPERA: 'Opera',
  SAMSUNG_BROWSER: 'Samsung Internet for Android',
  YANDEX_BROWSER: 'Yandex Browser',
  PUFFIN: 'Puffin',
  WINDOWS_PHONE: 'Windows Phone',
  INTERNET_EXPLORER: 'Internet Explorer',
  MICROSOFT_EDGE: 'Microsoft Edge',
  FIREFOX: 'Firefox',
  AMAZON_SILK: 'Amazon Silk',
  PHANTOM_JS: 'PhantomJS',
  CHROMIUM: 'Chromium',
  CHROME: 'Chrome',
  ANDROID: 'Android',
  SAFARI: 'Safari',
  VIVALDI: 'Vivaldi',
  UC_BROWSER: 'UC Browser',
  SEAMONKEY: 'SeaMonkey',
  IOS_WEBVIEW: 'iOS WebView',
  UNKNOWN: 'Unknown',
  QQ_BROWSER: 'QQ Browser',
  SOGOU_EXPLORER: 'Sogou Explorer',
  ANDROID_WEBVIEW: 'Android WebView',
  BLACKLISTED: 'Blacklisted'
};
/**
 * List of tests.
 */

var tests = [{
  browserName: names.BLACKLISTED,
  testRegex: /TapResearch|InfoQ|YJApp|infoQApp_Android|AnketkaAndroid/i,
  versionRegex: null
}, {
  browserName: names.VIVALDI,
  testRegex: /vivaldi/i,
  versionRegex: /(?:vivaldi)[\s/](\d+(\.\d+)?)/i
}, {
  browserName: names.QQ_BROWSER,
  testRegex: /qqbrowser/i,
  versionRegex: /(?:qqbrowser)[\s/](\d+(\.\d+)?)/i
}, {
  browserName: names.ANDROID_WEBVIEW,
  testRegex: /Android.*(wv|.0.0.0)/i,
  versionRegex: /(?:chrome|crios|crmo)\/(\d+(\.\d+)?)/i
}, {
  browserName: names.SOGOU_EXPLORER,
  testRegex: /sogou/i,
  versionRegex: /(?:sogou)[\s/]((\d+(\.(\d|[A-za-z])+)))/i
}, {
  browserName: names.UC_BROWSER,
  testRegex: /ucbrowser| ubrowser/i,
  versionRegex: /(?:ucbrowser| ubrowser)[\s/](\d+(\.\d+)?)/i
}, {
  browserName: names.SEAMONKEY,
  testRegex: /seamonkey/i,
  versionRegex: /(?:seamonkey)[\s/](\d+(\.\d+)?)/i
}, {
  browserName: names.OPERA,
  testRegex: /opera\/|opr\//i,
  versionRegex: /(?:opera |opios\/|opr\/)(\d+(\.\d+)?)/i
}, {
  browserName: names.SAMSUNG_BROWSER,
  testRegex: /SamsungBrowser/i,
  versionRegex: /(?:SamsungBrowser)[\s/](\d+(\.\d+)?)/i
}, {
  browserName: names.YANDEX_BROWSER,
  testRegex: /yabrowser/i,
  versionRegex: /(?:yabrowser)[\s/](\d+(\.\d+)?)/i
}, {
  browserName: names.PUFFIN,
  testRegex: /puffin/i,
  versionRegex: /(?:puffin)[\s/](\d+(?:\.\d+)?)/i
}, {
  browserName: names.WINDOWS_PHONE,
  testRegex: /windows phone/i,
  versionRegex: /(?:iemobile|edge)\/(\d+(\.\d+)?)/i
}, {
  browserName: names.INTERNET_EXPLORER,
  testRegex: /msie|trident/i,
  versionRegex: /(?:msie |rv:)(\d+(\.\d+)?)/i
}, {
  browserName: names.MICROSOFT_EDGE,
  testRegex: /(edge\/)/i,
  versionRegex: /(?:edge|edg)\/(\d+(\.\d+)?)/i
}, {
  browserName: names.FIREFOX,
  testRegex: /firefox|iceweasel|fxios/i,
  versionRegex: /(?:firefox|iceweasel|fxios)[ /](\d+(\.\d+)?)/i
}, {
  browserName: names.AMAZON_SILK,
  testRegex: /silk/i,
  versionRegex: /silk\/(\d+(\.\d+)?)/i
}, {
  browserName: names.PHANTOM_JS,
  testRegex: /phantom/i,
  versionRegex: /phantomjs\/(\d+(\.\d+)?)/i
}, {
  browserName: names.CHROMIUM,
  testRegex: /chromium/i,
  versionRegex: /(?:chromium)[\s/](\d+(?:\.\d+)?)/i
}, {
  browserName: names.CHROME,
  testRegex: /chrome|crios|crmo/i,
  versionRegex: /(?:chrome|crios|crmo)\/(\d+(\.\d+)?)/i
}, {
  browserName: names.ANDROID,
  testRegex: /android/i,
  versionRegex: null
}, {
  browserName: names.SAFARI,
  testRegex: /safari/i,
  versionRegex: /version\/(\d+(\.\d+)?)/i
}, {
  browserName: names.IOS_WEBVIEW,
  testRegex: /(iPhone|iPad).*AppleWebKit(?!.*Safari)/i,
  versionRegex: null
}];
var _default = {
  names: names,

  /**
   * Detects current browser name and version.
   *
   * @param {string} ua User Agent string
   * @return {{
   *   name: string,
   *   version: ?string
   * }}
   */
  detect: function detect(ua) {
    for (var i = 0; i < tests.length; i++) {
      if (tests[i].testRegex.test(ua)) {
        return {
          name: tests[i].browserName,
          version: (0, _getFirstMatch.default)(ua, tests[i].versionRegex) || (0, _getFirstMatch.default)(ua, /version\/(\d+(\.\d+)?)/i) || null
        };
      }
    }

    return {
      name: names.UNKNOWN,
      version: null
    };
  }
};
exports.default = _default;

},{"./utils/getFirstMatch":9}],3:[function(require,module,exports){
"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

/**
 * Capabilities detection.
 *
 * @copyright Realeyes OU. All rights reserved.
 */

/**
 * Enum for capabilities that we can detect.
 *
 * @enum
 */
var names = {
  GET_USER_MEDIA: 'navigator.getUserMedia',
  MEDIA_RECORDER: 'MediaRecorder',
  WEBCAM: 'webcam',
  DOCUMENT_ALL: 'document.all',
  DOCUMENT_QUERY_SELECTOR: 'document.querySelector',
  HTTP: 'http',
  HTTPS: 'https',
  LOCALHOST: 'localhost'
};
/**
 * List of tests.
 */

var tests = [{
  capabilityName: names.GET_USER_MEDIA,
  test: function test() {
    return !!(navigator.getUserMedia || navigator.webkitGetUserMedia || navigator.mozGetUserMedia || navigator.msGetUserMedia || navigator.mediaDevices && navigator.mediaDevices.getUserMedia);
  }
}, {
  capabilityName: names.MEDIA_RECORDER,
  test: function test() {
    return typeof window.MediaRecorder === 'function';
  }
}, {
  capabilityName: names.DOCUMENT_ALL,
  test: function test() {
    return document.querySelector !== undefined;
  }
}, {
  capabilityName: names.DOCUMENT_QUERY_SELECTOR,
  test: function test() {
    return typeof document.querySelector === 'function';
  }
}, {
  capabilityName: names.HTTP,
  test: function test() {
    return document.location.protocol === 'http:';
  }
}, {
  capabilityName: names.HTTPS,
  test: function test() {
    return document.location.protocol === 'https:';
  }
}, {
  capabilityName: names.LOCALHOST,
  test: function test() {
    return document.location.hostname === 'localhost' || document.location.hostname === '127.0.0.1';
  }
}];
var _default = {
  names: names,

  /**
   * Returns the list of capabilities available in current browser.
   *
   * @return {Array.<string>}
   */
  detect: function detect() {
    var results = [];

    for (var i = 0; i < tests.length; i++) {
      if (tests[i].test()) {
        results.push(tests[i].capabilityName);
      }
    }

    return results;
  }
};
exports.default = _default;

},{}],4:[function(require,module,exports){
"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = detect;

var _browsers = _interopRequireDefault(require("./browsers"));

var _platform = _interopRequireDefault(require("./platform"));

var _os = _interopRequireDefault(require("./os"));

var _capabilities = _interopRequireDefault(require("./capabilities"));

var _webcam = _interopRequireDefault(require("./webcam"));

var _Logger = _interopRequireDefault(require("./utils/Logger"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

/**
 * Environment detection function.
 *
 * @copyright Realeyes OU. All rights reserved.
 */

/**
 * @typedef {{
 *   browser: {
 *     name: string,
 *     version: string,
 *   },
 *   platform: {
 *     type: string,
 *   },
 *   os: {
 *     name: string,
 *     version: string,
 *   },
 *   webcams: Array.<string>,
 *   capabilities: Array.<string>,
 * }} EnvironmentDetectionResult
 */

/**
 * @typedef {{
 *   logger: ?{
 *      path: ?string,
 *      disable: ?boolean,
 *   },
 * }} EnvironmentDetectionOptions
 */

/**
 * @param {?EnvironmentDetectionOptions} options Options
 * @return {Promise.<EnvironmentDetectionResult>}
 */
function detect() {
  var options = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};
  var ua = navigator.userAgent;
  var logger = new _Logger.default(options.logger);
  logger.log('environment-detector started', options);
  return _webcam.default.detect().then(function (webcamsResult) {
    var result = {
      browser: _browsers.default.detect(ua),
      platform: _platform.default.detect(ua),
      os: _os.default.detect(ua),
      webcams: webcamsResult,
      capabilities: _capabilities.default.detect()
    }; // we can't detect ios_webview based on useragent string
    // we assume that if mobile safari 11+ is detected but without webrtc (getUserMedia) then it is a webview

    if (result.browser.name === _browsers.default.names.SAFARI && result.browser.version > '11' && !result.capabilities.find(function (c) {
      return c === _capabilities.default.names.GET_USER_MEDIA;
    })) {
      result.browser.name = _browsers.default.names.IOS_WEBVIEW;
    }

    logger.log('environment-detector result', result);
    return result;
  }).catch(function (e) {
    logger.log('environment-detector failed', e);
    throw e;
  });
}

},{"./browsers":2,"./capabilities":3,"./os":5,"./platform":6,"./utils/Logger":7,"./webcam":10}],5:[function(require,module,exports){
"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _getFirstMatch = _interopRequireDefault(require("./utils/getFirstMatch"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

/**
 * OS detection.
 *
 * @copyright Realeyes OU. All rights reserved.
 */

/**
 * Enum for OSs that we can detect.
 *
 * @enum {string}
 */
var names = {
  WINDOWS_PHONE: 'windowsphone',
  IOS: 'ios',
  ANDROID: 'android',
  MAC_OS: 'macos',
  WINDOWS: 'windows',
  LINUX: 'linux',
  OPENBSD: 'openbsd',
  CHROMEOS: 'chromeos',
  UNKNOWN: 'unknown'
};
/**
 * List of tests.
 */

var tests = [{
  osName: names.WINDOWS_PHONE,
  testRegex: /windows phone/i,
  getVersion: function getVersion(ua) {
    return (0, _getFirstMatch.default)(ua, /windows phone (?:os)?\s?(\d+(\.\d+)*)/i);
  }
}, {
  osName: names.IOS,
  testRegex: /(ipod|iphone|ipad)/i,
  getVersion: function getVersion(ua) {
    return (0, _getFirstMatch.default)(ua, /os (\d+([_\s]\d+)*) like mac os x/i).split('_').join('.');
  }
}, {
  osName: names.ANDROID,
  testRegex: /^((?!.*like android).*android)|silk/i,
  getVersion: function getVersion(ua) {
    return (0, _getFirstMatch.default)(ua, /android[ /-](\d+(\.\d+)*)/i);
  }
}, {
  osName: names.MAC_OS,
  testRegex: /macintosh/i,
  getVersion: function getVersion(ua) {
    return ua.replace(/.*?OS X (.*?)(\)|;).*/, '$1').split('_').join('.');
  }
}, {
  osName: names.WINDOWS,
  testRegex: /windows/i,
  getVersion: function getVersion(ua) {
    return ua.replace(/.*?Windows (.*?)(\)|;).*/, '$1');
  }
}, {
  osName: names.LINUX,
  testRegex: /linux/i,
  getVersion: function getVersion() {
    return null;
  }
}, {
  osName: names.OPENBSD,
  testRegex: /OpenBSD/i,
  getVersion: function getVersion() {
    return null;
  }
}, {
  osName: names.CHROMEOS,
  testRegex: /CrOS/i,
  getVersion: function getVersion() {
    return null;
  }
}];
var _default = {
  names: names,

  /**
   * Returns the OS name and version.
   *
   * @param {string} ua User Agent string
   * @return {{
   *   name: string,
   *   version: ?string
   * }}
   */
  detect: function detect(ua) {
    for (var i = 0; i < tests.length; i++) {
      if (tests[i].testRegex.test(ua)) {
        return {
          name: tests[i].osName,
          version: tests[i].getVersion(ua) || (0, _getFirstMatch.default)(ua, /version\/(\d+\.\d+)/i) || null
        };
      }
    }

    return {
      name: names.UNKNOWN,
      version: null
    };
  }
};
exports.default = _default;

},{"./utils/getFirstMatch":9}],6:[function(require,module,exports){
"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _getFirstMatch = _interopRequireDefault(require("./utils/getFirstMatch"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

/**
 * Platform detection.
 *
 * Based on code from https://github.com/ded/bowser by Dustin Diaz.
 *
 * @copyright Realeyes OU. All rights reserved.
 */

/**
 * Enum for platform types that we can detect.
 *
 * @enum {string}
 */
var types = {
  MOBILE: 'mobile',
  TABLET: 'tablet',
  DESKTOP: 'desktop'
};
var _default = {
  types: types,

  /**
   * Returns the platform type
   *
   * @param {string} ua User agent string
   * @return {{
   *   type: string
   * }}
   */
  detect: function detect(ua) {
    var tablet = /tablet/i.test(ua);
    var mobile = !tablet && /[^-]mobi/i.test(ua);
    var ios = (0, _getFirstMatch.default)(ua, /(ipod|iphone|ipad)/i).toLowerCase();
    var likeAndroid = /like android/i.test(ua);
    var android = !likeAndroid && /android/i.test(ua);
    var nexusMobile = /nexus\s*[0-6]\s*/i.test(ua);
    var nexusTablet = !nexusMobile && /nexus\s*[0-9]+/i.test(ua);
    var androidVersion = (0, _getFirstMatch.default)(ua, /android[ /-](\d+(\.\d+)*)/i).split('.')[0];
    var silk = /silk/i.test(ua);

    if (tablet || nexusTablet || ios === 'ipad' || android && (+androidVersion === 3 || +androidVersion >= 4 && !mobile) || silk) {
      return {
        type: types.TABLET
      };
    } else if (mobile || nexusMobile) {
      return {
        type: types.MOBILE
      };
    }

    return {
      type: types.DESKTOP
    };
  }
};
exports.default = _default;

},{"./utils/getFirstMatch":9}],7:[function(require,module,exports){
"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _nativePromiseOnly = _interopRequireDefault(require("native-promise-only"));

var _json = _interopRequireDefault(require("json3"));

var _v = _interopRequireDefault(require("uuid/v4"));

var _currentScriptPath = _interopRequireDefault(require("./currentScriptPath"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

var DEFAULT_LOGGER_PATH = "".concat(_currentScriptPath.default, "log.gif");

var Logger =
/*#__PURE__*/
function () {
  /**
   * Creates a Logger instance.
   *
   * @param {string} path Path to the tracking pixel
   * @param {boolean} disable Pass true to disable logging
   * @param {string} sid Session ID
   */
  function Logger() {
    var _ref = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {},
        _ref$path = _ref.path,
        path = _ref$path === void 0 ? DEFAULT_LOGGER_PATH : _ref$path,
        _ref$disable = _ref.disable,
        disable = _ref$disable === void 0 ? false : _ref$disable,
        _ref$sid = _ref.sid,
        sid = _ref$sid === void 0 ? (0, _v.default)() : _ref$sid;

    _classCallCheck(this, Logger);

    this.sid = sid;
    this.pending = _nativePromiseOnly.default.resolve();
    this.path = path;
    this.disabled = disable;
  }
  /**
   * Sends the log message.
   *
   * @param {string} name Log message name
   * @param {Object} data Log message payload
   * @return {undefined}
   */


  _createClass(Logger, [{
    key: "log",
    value: function log(name) {
      var _this = this;

      var data = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {};

      if (this.disabled) {
        return;
      }

      var msg = {
        ts: +new Date(),
        sid: this.sid,
        name: name,
        data: data
      };
      this.pending = this.pending.then(new _nativePromiseOnly.default(function (resolve) {
        var img = document.createElement('img');

        var done = function done() {
          img.parentNode.removeChild(img);
          resolve();
        };

        img.style.position = 'absolute';
        img.style.top = '-10px';
        img.onload = done;
        img.onerror = done;
        img.src = "".concat(_this.path, "?msg=").concat(encodeURIComponent(_json.default.stringify(msg)));
        document.body.appendChild(img);
      }));
    }
  }]);

  return Logger;
}();

exports.default = Logger;

},{"./currentScriptPath":8,"json3":11,"native-promise-only":12,"uuid/v4":17}],8:[function(require,module,exports){
"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

/**
 * currentScriptPath helper.
 *
 * @copyright Realeyes OU. All rights reserved.
 */

/**
 * Returns the current script path.
 *
 * @return {string}
 */
function getPath() {
  if (document.currentScript == null) {
    // only == means null or undefined
    // Guess the script path in old browsers that do not support "document.currentScript" by parsing the "src"
    // property of the last script tag in the document this will only work if the environment-checker.js bundle was
    // included in the html document directly not using "async" of "defer" attributes.
    // This will also give wrong result if the script tag was
    // embedded dynamically and was not inserted after the last script tag in the document.
    //
    // If the environment-checker.js was embedded using one of the mentioned techniques please use the
    // EnvironmentDetectionOptions to pass the flash.path string to the library.
    var scripts = document.getElementsByTagName('script');
    var src = scripts[scripts.length - 1].src.split('?')[0];
    return "".concat(src.split('/').slice(0, -1).join('/'), "/");
  }

  return "".concat(document.currentScript.src.split('/').slice(0, -1).join('/'), "/");
}

var _default = getPath();

exports.default = _default;

},{}],9:[function(require,module,exports){
"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

/**
 * getFirstMatch helper.
 *
 * @copyright Realeyes OU. All rights reserved.
 */

/**
 * Returns the first match for the regexp.
 *
 * @param {string} str String
 * @param {RegExp} regex Regular expression used for matching
 * @return {string}
 */
var _default = function _default(str, regex) {
  var match = str.match(regex);

  if (match && match.length > 1) {
    return match[1];
  }

  return '';
};

exports.default = _default;

},{}],10:[function(require,module,exports){
"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

/**
 * Webcam detection.
 *
 * @copyright Realeyes OU. All rights reserved.
 */
var _default = {
  /**
   * Returns the array of detected webcams.
   *
   * @return {Promise.<Array.<string>>}
   */
  detect: function detect() {
    if (navigator.mediaDevices && navigator.mediaDevices.enumerateDevices) {
      return navigator.mediaDevices.enumerateDevices().then(function (devices) {
        var result = [];

        for (var i = 0; i < devices.length; i++) {
          if (devices[i].kind === 'videoinput') {
            var name = devices[i].label ? devices[i].label : 'unknown';
            result.push(name);
          }
        } //TODO Investigate this if safari 13.1 fixed


        var userAgent = navigator.userAgent;
        var isAppleDevice = userAgent.toLowerCase().includes('mac os x');
        var isSafariBased = userAgent.toLowerCase().includes('safari');
        var isVersion131 = userAgent.toLowerCase().includes('version/13.1');

        if (result.length == 0 && isAppleDevice && isSafariBased && isVersion131) {
          var numberOfAudioInputDevices = 0;
          devices.forEach(function (device) {
            if (device.kind === 'audioinput') {
              numberOfAudioInputDevices++;
            }

            ;
          });

          if (numberOfAudioInputDevices >= 2) {
            result.push('unknown');
          }
        }

        return result;
      });
    }

    return Promise.resolve([]);
  }
};
exports.default = _default;

},{}],11:[function(require,module,exports){
(function (global){
"use strict";

function _typeof(obj) { if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

/*! JSON v3.3.2 | https://bestiejs.github.io/json3 | Copyright 2012-2015, Kit Cambridge, Benjamin Tan | http://kit.mit-license.org */
;
(function () {
  // Detect the `define` function exposed by asynchronous module loaders. The
  // strict `define` check is necessary for compatibility with `r.js`.
  var isLoader = typeof define === "function" && define.amd; // A set of types used to distinguish objects from primitives.

  var objectTypes = {
    "function": true,
    "object": true
  }; // Detect the `exports` object exposed by CommonJS implementations.

  var freeExports = objectTypes[typeof exports === "undefined" ? "undefined" : _typeof(exports)] && exports && !exports.nodeType && exports; // Use the `global` object exposed by Node (including Browserify via
  // `insert-module-globals`), Narwhal, and Ringo as the default context,
  // and the `window` object in browsers. Rhino exports a `global` function
  // instead.

  var root = objectTypes[typeof window === "undefined" ? "undefined" : _typeof(window)] && window || this,
      freeGlobal = freeExports && objectTypes[typeof module === "undefined" ? "undefined" : _typeof(module)] && module && !module.nodeType && (typeof global === "undefined" ? "undefined" : _typeof(global)) == "object" && global;

  if (freeGlobal && (freeGlobal.global === freeGlobal || freeGlobal.window === freeGlobal || freeGlobal.self === freeGlobal)) {
    root = freeGlobal;
  } // Public: Initializes JSON 3 using the given `context` object, attaching the
  // `stringify` and `parse` functions to the specified `exports` object.


  function runInContext(context, exports) {
    context || (context = root.Object());
    exports || (exports = root.Object()); // Native constructor aliases.

    var Number = context.Number || root.Number,
        String = context.String || root.String,
        Object = context.Object || root.Object,
        Date = context.Date || root.Date,
        SyntaxError = context.SyntaxError || root.SyntaxError,
        TypeError = context.TypeError || root.TypeError,
        Math = context.Math || root.Math,
        nativeJSON = context.JSON || root.JSON; // Delegate to the native `stringify` and `parse` implementations.

    if (_typeof(nativeJSON) == "object" && nativeJSON) {
      exports.stringify = nativeJSON.stringify;
      exports.parse = nativeJSON.parse;
    } // Convenience aliases.


    var objectProto = Object.prototype,
        getClass = objectProto.toString,
        isProperty = objectProto.hasOwnProperty,
        undefined; // Internal: Contains `try...catch` logic used by other functions.
    // This prevents other functions from being deoptimized.

    function attempt(func, errorFunc) {
      try {
        func();
      } catch (exception) {
        if (errorFunc) {
          errorFunc();
        }
      }
    } // Test the `Date#getUTC*` methods. Based on work by @Yaffle.


    var isExtended = new Date(-3509827334573292);
    attempt(function () {
      // The `getUTCFullYear`, `Month`, and `Date` methods return nonsensical
      // results for certain dates in Opera >= 10.53.
      isExtended = isExtended.getUTCFullYear() == -109252 && isExtended.getUTCMonth() === 0 && isExtended.getUTCDate() === 1 && isExtended.getUTCHours() == 10 && isExtended.getUTCMinutes() == 37 && isExtended.getUTCSeconds() == 6 && isExtended.getUTCMilliseconds() == 708;
    }); // Internal: Determines whether the native `JSON.stringify` and `parse`
    // implementations are spec-compliant. Based on work by Ken Snyder.

    function has(name) {
      if (has[name] != null) {
        // Return cached feature test result.
        return has[name];
      }

      var isSupported;

      if (name == "bug-string-char-index") {
        // IE <= 7 doesn't support accessing string characters using square
        // bracket notation. IE 8 only supports this for primitives.
        isSupported = "a"[0] != "a";
      } else if (name == "json") {
        // Indicates whether both `JSON.stringify` and `JSON.parse` are
        // supported.
        isSupported = has("json-stringify") && has("date-serialization") && has("json-parse");
      } else if (name == "date-serialization") {
        // Indicates whether `Date`s can be serialized accurately by `JSON.stringify`.
        isSupported = has("json-stringify") && isExtended;

        if (isSupported) {
          var stringify = exports.stringify;
          attempt(function () {
            isSupported = // JSON 2, Prototype <= 1.7, and older WebKit builds incorrectly
            // serialize extended years.
            stringify(new Date(-8.64e15)) == '"-271821-04-20T00:00:00.000Z"' && // The milliseconds are optional in ES 5, but required in 5.1.
            stringify(new Date(8.64e15)) == '"+275760-09-13T00:00:00.000Z"' && // Firefox <= 11.0 incorrectly serializes years prior to 0 as negative
            // four-digit years instead of six-digit years. Credits: @Yaffle.
            stringify(new Date(-621987552e5)) == '"-000001-01-01T00:00:00.000Z"' && // Safari <= 5.1.5 and Opera >= 10.53 incorrectly serialize millisecond
            // values less than 1000. Credits: @Yaffle.
            stringify(new Date(-1)) == '"1969-12-31T23:59:59.999Z"';
          });
        }
      } else {
        var value,
            serialized = "{\"a\":[1,true,false,null,\"\\u0000\\b\\n\\f\\r\\t\"]}"; // Test `JSON.stringify`.

        if (name == "json-stringify") {
          var stringify = exports.stringify,
              stringifySupported = typeof stringify == "function";

          if (stringifySupported) {
            // A test function object with a custom `toJSON` method.
            (value = function value() {
              return 1;
            }).toJSON = value;
            attempt(function () {
              stringifySupported = // Firefox 3.1b1 and b2 serialize string, number, and boolean
              // primitives as object literals.
              stringify(0) === "0" && // FF 3.1b1, b2, and JSON 2 serialize wrapped primitives as object
              // literals.
              stringify(new Number()) === "0" && stringify(new String()) == '""' && // FF 3.1b1, 2 throw an error if the value is `null`, `undefined`, or
              // does not define a canonical JSON representation (this applies to
              // objects with `toJSON` properties as well, *unless* they are nested
              // within an object or array).
              stringify(getClass) === undefined && // IE 8 serializes `undefined` as `"undefined"`. Safari <= 5.1.7 and
              // FF 3.1b3 pass this test.
              stringify(undefined) === undefined && // Safari <= 5.1.7 and FF 3.1b3 throw `Error`s and `TypeError`s,
              // respectively, if the value is omitted entirely.
              stringify() === undefined && // FF 3.1b1, 2 throw an error if the given value is not a number,
              // string, array, object, Boolean, or `null` literal. This applies to
              // objects with custom `toJSON` methods as well, unless they are nested
              // inside object or array literals. YUI 3.0.0b1 ignores custom `toJSON`
              // methods entirely.
              stringify(value) === "1" && stringify([value]) == "[1]" && // Prototype <= 1.6.1 serializes `[undefined]` as `"[]"` instead of
              // `"[null]"`.
              stringify([undefined]) == "[null]" && // YUI 3.0.0b1 fails to serialize `null` literals.
              stringify(null) == "null" && // FF 3.1b1, 2 halts serialization if an array contains a function:
              // `[1, true, getClass, 1]` serializes as "[1,true,],". FF 3.1b3
              // elides non-JSON values from objects and arrays, unless they
              // define custom `toJSON` methods.
              stringify([undefined, getClass, null]) == "[null,null,null]" && // Simple serialization test. FF 3.1b1 uses Unicode escape sequences
              // where character escape codes are expected (e.g., `\b` => `\u0008`).
              stringify({
                "a": [value, true, false, null, "\x00\b\n\f\r\t"]
              }) == serialized && // FF 3.1b1 and b2 ignore the `filter` and `width` arguments.
              stringify(null, value) === "1" && stringify([1, 2], null, 1) == "[\n 1,\n 2\n]";
            }, function () {
              stringifySupported = false;
            });
          }

          isSupported = stringifySupported;
        } // Test `JSON.parse`.


        if (name == "json-parse") {
          var parse = exports.parse,
              parseSupported;

          if (typeof parse == "function") {
            attempt(function () {
              // FF 3.1b1, b2 will throw an exception if a bare literal is provided.
              // Conforming implementations should also coerce the initial argument to
              // a string prior to parsing.
              if (parse("0") === 0 && !parse(false)) {
                // Simple parsing test.
                value = parse(serialized);
                parseSupported = value["a"].length == 5 && value["a"][0] === 1;

                if (parseSupported) {
                  attempt(function () {
                    // Safari <= 5.1.2 and FF 3.1b1 allow unescaped tabs in strings.
                    parseSupported = !parse('"\t"');
                  });

                  if (parseSupported) {
                    attempt(function () {
                      // FF 4.0 and 4.0.1 allow leading `+` signs and leading
                      // decimal points. FF 4.0, 4.0.1, and IE 9-10 also allow
                      // certain octal literals.
                      parseSupported = parse("01") !== 1;
                    });
                  }

                  if (parseSupported) {
                    attempt(function () {
                      // FF 4.0, 4.0.1, and Rhino 1.7R3-R4 allow trailing decimal
                      // points. These environments, along with FF 3.1b1 and 2,
                      // also allow trailing commas in JSON objects and arrays.
                      parseSupported = parse("1.") !== 1;
                    });
                  }
                }
              }
            }, function () {
              parseSupported = false;
            });
          }

          isSupported = parseSupported;
        }
      }

      return has[name] = !!isSupported;
    }

    has["bug-string-char-index"] = has["date-serialization"] = has["json"] = has["json-stringify"] = has["json-parse"] = null;

    if (!has("json")) {
      // Common `[[Class]]` name aliases.
      var functionClass = "[object Function]",
          dateClass = "[object Date]",
          numberClass = "[object Number]",
          stringClass = "[object String]",
          arrayClass = "[object Array]",
          booleanClass = "[object Boolean]"; // Detect incomplete support for accessing string characters by index.

      var charIndexBuggy = has("bug-string-char-index"); // Internal: Normalizes the `for...in` iteration algorithm across
      // environments. Each enumerated key is yielded to a `callback` function.

      var _forOwn = function forOwn(object, callback) {
        var size = 0,
            Properties,
            dontEnums,
            property; // Tests for bugs in the current environment's `for...in` algorithm. The
        // `valueOf` property inherits the non-enumerable flag from
        // `Object.prototype` in older versions of IE, Netscape, and Mozilla.

        (Properties = function Properties() {
          this.valueOf = 0;
        }).prototype.valueOf = 0; // Iterate over a new instance of the `Properties` class.

        dontEnums = new Properties();

        for (property in dontEnums) {
          // Ignore all properties inherited from `Object.prototype`.
          if (isProperty.call(dontEnums, property)) {
            size++;
          }
        }

        Properties = dontEnums = null; // Normalize the iteration algorithm.

        if (!size) {
          // A list of non-enumerable properties inherited from `Object.prototype`.
          dontEnums = ["valueOf", "toString", "toLocaleString", "propertyIsEnumerable", "isPrototypeOf", "hasOwnProperty", "constructor"]; // IE <= 8, Mozilla 1.0, and Netscape 6.2 ignore shadowed non-enumerable
          // properties.

          _forOwn = function forOwn(object, callback) {
            var isFunction = getClass.call(object) == functionClass,
                property,
                length;
            var hasProperty = !isFunction && typeof object.constructor != "function" && objectTypes[_typeof(object.hasOwnProperty)] && object.hasOwnProperty || isProperty;

            for (property in object) {
              // Gecko <= 1.0 enumerates the `prototype` property of functions under
              // certain conditions; IE does not.
              if (!(isFunction && property == "prototype") && hasProperty.call(object, property)) {
                callback(property);
              }
            } // Manually invoke the callback for each non-enumerable property.


            for (length = dontEnums.length; property = dontEnums[--length];) {
              if (hasProperty.call(object, property)) {
                callback(property);
              }
            }
          };
        } else {
          // No bugs detected; use the standard `for...in` algorithm.
          _forOwn = function forOwn(object, callback) {
            var isFunction = getClass.call(object) == functionClass,
                property,
                isConstructor;

            for (property in object) {
              if (!(isFunction && property == "prototype") && isProperty.call(object, property) && !(isConstructor = property === "constructor")) {
                callback(property);
              }
            } // Manually invoke the callback for the `constructor` property due to
            // cross-environment inconsistencies.


            if (isConstructor || isProperty.call(object, property = "constructor")) {
              callback(property);
            }
          };
        }

        return _forOwn(object, callback);
      }; // Public: Serializes a JavaScript `value` as a JSON string. The optional
      // `filter` argument may specify either a function that alters how object and
      // array members are serialized, or an array of strings and numbers that
      // indicates which properties should be serialized. The optional `width`
      // argument may be either a string or number that specifies the indentation
      // level of the output.


      if (!has("json-stringify") && !has("date-serialization")) {
        // Internal: A map of control characters and their escaped equivalents.
        var Escapes = {
          92: "\\\\",
          34: '\\"',
          8: "\\b",
          12: "\\f",
          10: "\\n",
          13: "\\r",
          9: "\\t"
        }; // Internal: Converts `value` into a zero-padded string such that its
        // length is at least equal to `width`. The `width` must be <= 6.

        var leadingZeroes = "000000";

        var toPaddedString = function toPaddedString(width, value) {
          // The `|| 0` expression is necessary to work around a bug in
          // Opera <= 7.54u2 where `0 == -0`, but `String(-0) !== "0"`.
          return (leadingZeroes + (value || 0)).slice(-width);
        }; // Internal: Serializes a date object.


        var _serializeDate = function serializeDate(value) {
          var getData, year, month, date, time, hours, minutes, seconds, milliseconds; // Define additional utility methods if the `Date` methods are buggy.

          if (!isExtended) {
            var floor = Math.floor; // A mapping between the months of the year and the number of days between
            // January 1st and the first of the respective month.

            var Months = [0, 31, 59, 90, 120, 151, 181, 212, 243, 273, 304, 334]; // Internal: Calculates the number of days between the Unix epoch and the
            // first day of the given month.

            var getDay = function getDay(year, month) {
              return Months[month] + 365 * (year - 1970) + floor((year - 1969 + (month = +(month > 1))) / 4) - floor((year - 1901 + month) / 100) + floor((year - 1601 + month) / 400);
            };

            getData = function getData(value) {
              // Manually compute the year, month, date, hours, minutes,
              // seconds, and milliseconds if the `getUTC*` methods are
              // buggy. Adapted from @Yaffle's `date-shim` project.
              date = floor(value / 864e5);

              for (year = floor(date / 365.2425) + 1970 - 1; getDay(year + 1, 0) <= date; year++) {
                ;
              }

              for (month = floor((date - getDay(year, 0)) / 30.42); getDay(year, month + 1) <= date; month++) {
                ;
              }

              date = 1 + date - getDay(year, month); // The `time` value specifies the time within the day (see ES
              // 5.1 section 15.9.1.2). The formula `(A % B + B) % B` is used
              // to compute `A modulo B`, as the `%` operator does not
              // correspond to the `modulo` operation for negative numbers.

              time = (value % 864e5 + 864e5) % 864e5; // The hours, minutes, seconds, and milliseconds are obtained by
              // decomposing the time within the day. See section 15.9.1.10.

              hours = floor(time / 36e5) % 24;
              minutes = floor(time / 6e4) % 60;
              seconds = floor(time / 1e3) % 60;
              milliseconds = time % 1e3;
            };
          } else {
            getData = function getData(value) {
              year = value.getUTCFullYear();
              month = value.getUTCMonth();
              date = value.getUTCDate();
              hours = value.getUTCHours();
              minutes = value.getUTCMinutes();
              seconds = value.getUTCSeconds();
              milliseconds = value.getUTCMilliseconds();
            };
          }

          _serializeDate = function serializeDate(value) {
            if (value > -1 / 0 && value < 1 / 0) {
              // Dates are serialized according to the `Date#toJSON` method
              // specified in ES 5.1 section 15.9.5.44. See section 15.9.1.15
              // for the ISO 8601 date time string format.
              getData(value); // Serialize extended years correctly.

              value = (year <= 0 || year >= 1e4 ? (year < 0 ? "-" : "+") + toPaddedString(6, year < 0 ? -year : year) : toPaddedString(4, year)) + "-" + toPaddedString(2, month + 1) + "-" + toPaddedString(2, date) + // Months, dates, hours, minutes, and seconds should have two
              // digits; milliseconds should have three.
              "T" + toPaddedString(2, hours) + ":" + toPaddedString(2, minutes) + ":" + toPaddedString(2, seconds) + // Milliseconds are optional in ES 5.0, but required in 5.1.
              "." + toPaddedString(3, milliseconds) + "Z";
              year = month = date = hours = minutes = seconds = milliseconds = null;
            } else {
              value = null;
            }

            return value;
          };

          return _serializeDate(value);
        }; // For environments with `JSON.stringify` but buggy date serialization,
        // we override the native `Date#toJSON` implementation with a
        // spec-compliant one.


        if (has("json-stringify") && !has("date-serialization")) {
          // Internal: the `Date#toJSON` implementation used to override the native one.
          var dateToJSON = function dateToJSON(key) {
            return _serializeDate(this);
          }; // Public: `JSON.stringify`. See ES 5.1 section 15.12.3.


          var nativeStringify = exports.stringify;

          exports.stringify = function (source, filter, width) {
            var nativeToJSON = Date.prototype.toJSON;
            Date.prototype.toJSON = dateToJSON;
            var result = nativeStringify(source, filter, width);
            Date.prototype.toJSON = nativeToJSON;
            return result;
          };
        } else {
          // Internal: Double-quotes a string `value`, replacing all ASCII control
          // characters (characters with code unit values between 0 and 31) with
          // their escaped equivalents. This is an implementation of the
          // `Quote(value)` operation defined in ES 5.1 section 15.12.3.
          var unicodePrefix = "\\u00";

          var escapeChar = function escapeChar(character) {
            var charCode = character.charCodeAt(0),
                escaped = Escapes[charCode];

            if (escaped) {
              return escaped;
            }

            return unicodePrefix + toPaddedString(2, charCode.toString(16));
          };

          var reEscape = /[\x00-\x1f\x22\x5c]/g;

          var quote = function quote(value) {
            reEscape.lastIndex = 0;
            return '"' + (reEscape.test(value) ? value.replace(reEscape, escapeChar) : value) + '"';
          }; // Internal: Recursively serializes an object. Implements the
          // `Str(key, holder)`, `JO(value)`, and `JA(value)` operations.


          var serialize = function serialize(property, object, callback, properties, whitespace, indentation, stack) {
            var value, type, className, results, element, index, length, prefix, result;
            attempt(function () {
              // Necessary for host object support.
              value = object[property];
            });

            if (_typeof(value) == "object" && value) {
              if (value.getUTCFullYear && getClass.call(value) == dateClass && value.toJSON === Date.prototype.toJSON) {
                value = _serializeDate(value);
              } else if (typeof value.toJSON == "function") {
                value = value.toJSON(property);
              }
            }

            if (callback) {
              // If a replacement function was provided, call it to obtain the value
              // for serialization.
              value = callback.call(object, property, value);
            } // Exit early if value is `undefined` or `null`.


            if (value == undefined) {
              return value === undefined ? value : "null";
            }

            type = _typeof(value); // Only call `getClass` if the value is an object.

            if (type == "object") {
              className = getClass.call(value);
            }

            switch (className || type) {
              case "boolean":
              case booleanClass:
                // Booleans are represented literally.
                return "" + value;

              case "number":
              case numberClass:
                // JSON numbers must be finite. `Infinity` and `NaN` are serialized as
                // `"null"`.
                return value > -1 / 0 && value < 1 / 0 ? "" + value : "null";

              case "string":
              case stringClass:
                // Strings are double-quoted and escaped.
                return quote("" + value);
            } // Recursively serialize objects and arrays.


            if (_typeof(value) == "object") {
              // Check for cyclic structures. This is a linear search; performance
              // is inversely proportional to the number of unique nested objects.
              for (length = stack.length; length--;) {
                if (stack[length] === value) {
                  // Cyclic structures cannot be serialized by `JSON.stringify`.
                  throw TypeError();
                }
              } // Add the object to the stack of traversed objects.


              stack.push(value);
              results = []; // Save the current indentation level and indent one additional level.

              prefix = indentation;
              indentation += whitespace;

              if (className == arrayClass) {
                // Recursively serialize array elements.
                for (index = 0, length = value.length; index < length; index++) {
                  element = serialize(index, value, callback, properties, whitespace, indentation, stack);
                  results.push(element === undefined ? "null" : element);
                }

                result = results.length ? whitespace ? "[\n" + indentation + results.join(",\n" + indentation) + "\n" + prefix + "]" : "[" + results.join(",") + "]" : "[]";
              } else {
                // Recursively serialize object members. Members are selected from
                // either a user-specified list of property names, or the object
                // itself.
                _forOwn(properties || value, function (property) {
                  var element = serialize(property, value, callback, properties, whitespace, indentation, stack);

                  if (element !== undefined) {
                    // According to ES 5.1 section 15.12.3: "If `gap` {whitespace}
                    // is not the empty string, let `member` {quote(property) + ":"}
                    // be the concatenation of `member` and the `space` character."
                    // The "`space` character" refers to the literal space
                    // character, not the `space` {width} argument provided to
                    // `JSON.stringify`.
                    results.push(quote(property) + ":" + (whitespace ? " " : "") + element);
                  }
                });

                result = results.length ? whitespace ? "{\n" + indentation + results.join(",\n" + indentation) + "\n" + prefix + "}" : "{" + results.join(",") + "}" : "{}";
              } // Remove the object from the traversed object stack.


              stack.pop();
              return result;
            }
          }; // Public: `JSON.stringify`. See ES 5.1 section 15.12.3.


          exports.stringify = function (source, filter, width) {
            var whitespace, callback, properties, className;

            if (objectTypes[_typeof(filter)] && filter) {
              className = getClass.call(filter);

              if (className == functionClass) {
                callback = filter;
              } else if (className == arrayClass) {
                // Convert the property names array into a makeshift set.
                properties = {};

                for (var index = 0, length = filter.length, value; index < length;) {
                  value = filter[index++];
                  className = getClass.call(value);

                  if (className == "[object String]" || className == "[object Number]") {
                    properties[value] = 1;
                  }
                }
              }
            }

            if (width) {
              className = getClass.call(width);

              if (className == numberClass) {
                // Convert the `width` to an integer and create a string containing
                // `width` number of space characters.
                if ((width -= width % 1) > 0) {
                  if (width > 10) {
                    width = 10;
                  }

                  for (whitespace = ""; whitespace.length < width;) {
                    whitespace += " ";
                  }
                }
              } else if (className == stringClass) {
                whitespace = width.length <= 10 ? width : width.slice(0, 10);
              }
            } // Opera <= 7.54u2 discards the values associated with empty string keys
            // (`""`) only if they are used directly within an object member list
            // (e.g., `!("" in { "": 1})`).


            return serialize("", (value = {}, value[""] = source, value), callback, properties, whitespace, "", []);
          };
        }
      } // Public: Parses a JSON source string.


      if (!has("json-parse")) {
        var fromCharCode = String.fromCharCode; // Internal: A map of escaped control characters and their unescaped
        // equivalents.

        var Unescapes = {
          92: "\\",
          34: '"',
          47: "/",
          98: "\b",
          116: "\t",
          110: "\n",
          102: "\f",
          114: "\r"
        }; // Internal: Stores the parser state.

        var Index, Source; // Internal: Resets the parser state and throws a `SyntaxError`.

        var abort = function abort() {
          Index = Source = null;
          throw SyntaxError();
        }; // Internal: Returns the next token, or `"$"` if the parser has reached
        // the end of the source string. A token may be a string, number, `null`
        // literal, or Boolean literal.


        var lex = function lex() {
          var source = Source,
              length = source.length,
              value,
              begin,
              position,
              isSigned,
              charCode;

          while (Index < length) {
            charCode = source.charCodeAt(Index);

            switch (charCode) {
              case 9:
              case 10:
              case 13:
              case 32:
                // Skip whitespace tokens, including tabs, carriage returns, line
                // feeds, and space characters.
                Index++;
                break;

              case 123:
              case 125:
              case 91:
              case 93:
              case 58:
              case 44:
                // Parse a punctuator token (`{`, `}`, `[`, `]`, `:`, or `,`) at
                // the current position.
                value = charIndexBuggy ? source.charAt(Index) : source[Index];
                Index++;
                return value;

              case 34:
                // `"` delimits a JSON string; advance to the next character and
                // begin parsing the string. String tokens are prefixed with the
                // sentinel `@` character to distinguish them from punctuators and
                // end-of-string tokens.
                for (value = "@", Index++; Index < length;) {
                  charCode = source.charCodeAt(Index);

                  if (charCode < 32) {
                    // Unescaped ASCII control characters (those with a code unit
                    // less than the space character) are not permitted.
                    abort();
                  } else if (charCode == 92) {
                    // A reverse solidus (`\`) marks the beginning of an escaped
                    // control character (including `"`, `\`, and `/`) or Unicode
                    // escape sequence.
                    charCode = source.charCodeAt(++Index);

                    switch (charCode) {
                      case 92:
                      case 34:
                      case 47:
                      case 98:
                      case 116:
                      case 110:
                      case 102:
                      case 114:
                        // Revive escaped control characters.
                        value += Unescapes[charCode];
                        Index++;
                        break;

                      case 117:
                        // `\u` marks the beginning of a Unicode escape sequence.
                        // Advance to the first character and validate the
                        // four-digit code point.
                        begin = ++Index;

                        for (position = Index + 4; Index < position; Index++) {
                          charCode = source.charCodeAt(Index); // A valid sequence comprises four hexdigits (case-
                          // insensitive) that form a single hexadecimal value.

                          if (!(charCode >= 48 && charCode <= 57 || charCode >= 97 && charCode <= 102 || charCode >= 65 && charCode <= 70)) {
                            // Invalid Unicode escape sequence.
                            abort();
                          }
                        } // Revive the escaped character.


                        value += fromCharCode("0x" + source.slice(begin, Index));
                        break;

                      default:
                        // Invalid escape sequence.
                        abort();
                    }
                  } else {
                    if (charCode == 34) {
                      // An unescaped double-quote character marks the end of the
                      // string.
                      break;
                    }

                    charCode = source.charCodeAt(Index);
                    begin = Index; // Optimize for the common case where a string is valid.

                    while (charCode >= 32 && charCode != 92 && charCode != 34) {
                      charCode = source.charCodeAt(++Index);
                    } // Append the string as-is.


                    value += source.slice(begin, Index);
                  }
                }

                if (source.charCodeAt(Index) == 34) {
                  // Advance to the next character and return the revived string.
                  Index++;
                  return value;
                } // Unterminated string.


                abort();

              default:
                // Parse numbers and literals.
                begin = Index; // Advance past the negative sign, if one is specified.

                if (charCode == 45) {
                  isSigned = true;
                  charCode = source.charCodeAt(++Index);
                } // Parse an integer or floating-point value.


                if (charCode >= 48 && charCode <= 57) {
                  // Leading zeroes are interpreted as octal literals.
                  if (charCode == 48 && (charCode = source.charCodeAt(Index + 1), charCode >= 48 && charCode <= 57)) {
                    // Illegal octal literal.
                    abort();
                  }

                  isSigned = false; // Parse the integer component.

                  for (; Index < length && (charCode = source.charCodeAt(Index), charCode >= 48 && charCode <= 57); Index++) {
                    ;
                  } // Floats cannot contain a leading decimal point; however, this
                  // case is already accounted for by the parser.


                  if (source.charCodeAt(Index) == 46) {
                    position = ++Index; // Parse the decimal component.

                    for (; position < length; position++) {
                      charCode = source.charCodeAt(position);

                      if (charCode < 48 || charCode > 57) {
                        break;
                      }
                    }

                    if (position == Index) {
                      // Illegal trailing decimal.
                      abort();
                    }

                    Index = position;
                  } // Parse exponents. The `e` denoting the exponent is
                  // case-insensitive.


                  charCode = source.charCodeAt(Index);

                  if (charCode == 101 || charCode == 69) {
                    charCode = source.charCodeAt(++Index); // Skip past the sign following the exponent, if one is
                    // specified.

                    if (charCode == 43 || charCode == 45) {
                      Index++;
                    } // Parse the exponential component.


                    for (position = Index; position < length; position++) {
                      charCode = source.charCodeAt(position);

                      if (charCode < 48 || charCode > 57) {
                        break;
                      }
                    }

                    if (position == Index) {
                      // Illegal empty exponent.
                      abort();
                    }

                    Index = position;
                  } // Coerce the parsed value to a JavaScript number.


                  return +source.slice(begin, Index);
                } // A negative sign may only precede numbers.


                if (isSigned) {
                  abort();
                } // `true`, `false`, and `null` literals.


                var temp = source.slice(Index, Index + 4);

                if (temp == "true") {
                  Index += 4;
                  return true;
                } else if (temp == "fals" && source.charCodeAt(Index + 4) == 101) {
                  Index += 5;
                  return false;
                } else if (temp == "null") {
                  Index += 4;
                  return null;
                } // Unrecognized token.


                abort();
            }
          } // Return the sentinel `$` character if the parser has reached the end
          // of the source string.


          return "$";
        }; // Internal: Parses a JSON `value` token.


        var get = function get(value) {
          var results, hasMembers;

          if (value == "$") {
            // Unexpected end of input.
            abort();
          }

          if (typeof value == "string") {
            if ((charIndexBuggy ? value.charAt(0) : value[0]) == "@") {
              // Remove the sentinel `@` character.
              return value.slice(1);
            } // Parse object and array literals.


            if (value == "[") {
              // Parses a JSON array, returning a new JavaScript array.
              results = [];

              for (;;) {
                value = lex(); // A closing square bracket marks the end of the array literal.

                if (value == "]") {
                  break;
                } // If the array literal contains elements, the current token
                // should be a comma separating the previous element from the
                // next.


                if (hasMembers) {
                  if (value == ",") {
                    value = lex();

                    if (value == "]") {
                      // Unexpected trailing `,` in array literal.
                      abort();
                    }
                  } else {
                    // A `,` must separate each array element.
                    abort();
                  }
                } else {
                  hasMembers = true;
                } // Elisions and leading commas are not permitted.


                if (value == ",") {
                  abort();
                }

                results.push(get(value));
              }

              return results;
            } else if (value == "{") {
              // Parses a JSON object, returning a new JavaScript object.
              results = {};

              for (;;) {
                value = lex(); // A closing curly brace marks the end of the object literal.

                if (value == "}") {
                  break;
                } // If the object literal contains members, the current token
                // should be a comma separator.


                if (hasMembers) {
                  if (value == ",") {
                    value = lex();

                    if (value == "}") {
                      // Unexpected trailing `,` in object literal.
                      abort();
                    }
                  } else {
                    // A `,` must separate each object member.
                    abort();
                  }
                } else {
                  hasMembers = true;
                } // Leading commas are not permitted, object property names must be
                // double-quoted strings, and a `:` must separate each property
                // name and value.


                if (value == "," || typeof value != "string" || (charIndexBuggy ? value.charAt(0) : value[0]) != "@" || lex() != ":") {
                  abort();
                }

                results[value.slice(1)] = get(lex());
              }

              return results;
            } // Unexpected token encountered.


            abort();
          }

          return value;
        }; // Internal: Updates a traversed object member.


        var update = function update(source, property, callback) {
          var element = walk(source, property, callback);

          if (element === undefined) {
            delete source[property];
          } else {
            source[property] = element;
          }
        }; // Internal: Recursively traverses a parsed JSON object, invoking the
        // `callback` function for each value. This is an implementation of the
        // `Walk(holder, name)` operation defined in ES 5.1 section 15.12.2.


        var walk = function walk(source, property, callback) {
          var value = source[property],
              length;

          if (_typeof(value) == "object" && value) {
            // `forOwn` can't be used to traverse an array in Opera <= 8.54
            // because its `Object#hasOwnProperty` implementation returns `false`
            // for array indices (e.g., `![1, 2, 3].hasOwnProperty("0")`).
            if (getClass.call(value) == arrayClass) {
              for (length = value.length; length--;) {
                update(getClass, _forOwn, value, length, callback);
              }
            } else {
              _forOwn(value, function (property) {
                update(value, property, callback);
              });
            }
          }

          return callback.call(source, property, value);
        }; // Public: `JSON.parse`. See ES 5.1 section 15.12.2.


        exports.parse = function (source, callback) {
          var result, value;
          Index = 0;
          Source = "" + source;
          result = get(lex()); // If a JSON string contains multiple tokens, it is invalid.

          if (lex() != "$") {
            abort();
          } // Reset the parser state.


          Index = Source = null;
          return callback && getClass.call(callback) == functionClass ? walk((value = {}, value[""] = result, value), "", callback) : result;
        };
      }
    }

    exports.runInContext = runInContext;
    return exports;
  }

  if (freeExports && !isLoader) {
    // Export for CommonJS environments.
    runInContext(root, freeExports);
  } else {
    // Export for web browsers and JavaScript engines.
    var nativeJSON = root.JSON,
        previousJSON = root.JSON3,
        isRestored = false;
    var JSON3 = runInContext(root, root.JSON3 = {
      // Public: Restores the original value of the global `JSON` object and
      // returns a reference to the `JSON3` object.
      "noConflict": function noConflict() {
        if (!isRestored) {
          isRestored = true;
          root.JSON = nativeJSON;
          root.JSON3 = previousJSON;
          nativeJSON = previousJSON = null;
        }

        return JSON3;
      }
    });
    root.JSON = {
      "parse": JSON3.parse,
      "stringify": JSON3.stringify
    };
  } // Export for asynchronous module loaders.


  if (isLoader) {
    define(function () {
      return JSON3;
    });
  }
}).call(void 0);

}).call(this,typeof global !== "undefined" ? global : typeof self !== "undefined" ? self : typeof window !== "undefined" ? window : {})

},{}],12:[function(require,module,exports){
(function (global,setImmediate){
"use strict";

function _typeof(obj) { if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

/*! Native Promise Only
    v0.8.1 (c) Kyle Simpson
    MIT License: http://getify.mit-license.org
*/
(function UMD(name, context, definition) {
  // special form of UMD for polyfilling across evironments
  context[name] = context[name] || definition();

  if (typeof module != "undefined" && module.exports) {
    module.exports = context[name];
  } else if (typeof define == "function" && define.amd) {
    define(function $AMD$() {
      return context[name];
    });
  }
})("Promise", typeof global != "undefined" ? global : void 0, function DEF() {
  /*jshint validthis:true */
  "use strict";

  var builtInProp,
      cycle,
      scheduling_queue,
      ToString = Object.prototype.toString,
      timer = typeof setImmediate != "undefined" ? function timer(fn) {
    return setImmediate(fn);
  } : setTimeout; // dammit, IE8.

  try {
    Object.defineProperty({}, "x", {});

    builtInProp = function builtInProp(obj, name, val, config) {
      return Object.defineProperty(obj, name, {
        value: val,
        writable: true,
        configurable: config !== false
      });
    };
  } catch (err) {
    builtInProp = function builtInProp(obj, name, val) {
      obj[name] = val;
      return obj;
    };
  } // Note: using a queue instead of array for efficiency


  scheduling_queue = function Queue() {
    var first, last, item;

    function Item(fn, self) {
      this.fn = fn;
      this.self = self;
      this.next = void 0;
    }

    return {
      add: function add(fn, self) {
        item = new Item(fn, self);

        if (last) {
          last.next = item;
        } else {
          first = item;
        }

        last = item;
        item = void 0;
      },
      drain: function drain() {
        var f = first;
        first = last = cycle = void 0;

        while (f) {
          f.fn.call(f.self);
          f = f.next;
        }
      }
    };
  }();

  function schedule(fn, self) {
    scheduling_queue.add(fn, self);

    if (!cycle) {
      cycle = timer(scheduling_queue.drain);
    }
  } // promise duck typing


  function isThenable(o) {
    var _then,
        o_type = _typeof(o);

    if (o != null && (o_type == "object" || o_type == "function")) {
      _then = o.then;
    }

    return typeof _then == "function" ? _then : false;
  }

  function notify() {
    for (var i = 0; i < this.chain.length; i++) {
      notifyIsolated(this, this.state === 1 ? this.chain[i].success : this.chain[i].failure, this.chain[i]);
    }

    this.chain.length = 0;
  } // NOTE: This is a separate function to isolate
  // the `try..catch` so that other code can be
  // optimized better


  function notifyIsolated(self, cb, chain) {
    var ret, _then;

    try {
      if (cb === false) {
        chain.reject(self.msg);
      } else {
        if (cb === true) {
          ret = self.msg;
        } else {
          ret = cb.call(void 0, self.msg);
        }

        if (ret === chain.promise) {
          chain.reject(TypeError("Promise-chain cycle"));
        } else if (_then = isThenable(ret)) {
          _then.call(ret, chain.resolve, chain.reject);
        } else {
          chain.resolve(ret);
        }
      }
    } catch (err) {
      chain.reject(err);
    }
  }

  function resolve(msg) {
    var _then,
        self = this; // already triggered?


    if (self.triggered) {
      return;
    }

    self.triggered = true; // unwrap

    if (self.def) {
      self = self.def;
    }

    try {
      if (_then = isThenable(msg)) {
        schedule(function () {
          var def_wrapper = new MakeDefWrapper(self);

          try {
            _then.call(msg, function $resolve$() {
              resolve.apply(def_wrapper, arguments);
            }, function $reject$() {
              reject.apply(def_wrapper, arguments);
            });
          } catch (err) {
            reject.call(def_wrapper, err);
          }
        });
      } else {
        self.msg = msg;
        self.state = 1;

        if (self.chain.length > 0) {
          schedule(notify, self);
        }
      }
    } catch (err) {
      reject.call(new MakeDefWrapper(self), err);
    }
  }

  function reject(msg) {
    var self = this; // already triggered?

    if (self.triggered) {
      return;
    }

    self.triggered = true; // unwrap

    if (self.def) {
      self = self.def;
    }

    self.msg = msg;
    self.state = 2;

    if (self.chain.length > 0) {
      schedule(notify, self);
    }
  }

  function iteratePromises(Constructor, arr, resolver, rejecter) {
    for (var idx = 0; idx < arr.length; idx++) {
      (function IIFE(idx) {
        Constructor.resolve(arr[idx]).then(function $resolver$(msg) {
          resolver(idx, msg);
        }, rejecter);
      })(idx);
    }
  }

  function MakeDefWrapper(self) {
    this.def = self;
    this.triggered = false;
  }

  function MakeDef(self) {
    this.promise = self;
    this.state = 0;
    this.triggered = false;
    this.chain = [];
    this.msg = void 0;
  }

  function Promise(executor) {
    if (typeof executor != "function") {
      throw TypeError("Not a function");
    }

    if (this.__NPO__ !== 0) {
      throw TypeError("Not a promise");
    } // instance shadowing the inherited "brand"
    // to signal an already "initialized" promise


    this.__NPO__ = 1;
    var def = new MakeDef(this);

    this["then"] = function then(success, failure) {
      var o = {
        success: typeof success == "function" ? success : true,
        failure: typeof failure == "function" ? failure : false
      }; // Note: `then(..)` itself can be borrowed to be used against
      // a different promise constructor for making the chained promise,
      // by substituting a different `this` binding.

      o.promise = new this.constructor(function extractChain(resolve, reject) {
        if (typeof resolve != "function" || typeof reject != "function") {
          throw TypeError("Not a function");
        }

        o.resolve = resolve;
        o.reject = reject;
      });
      def.chain.push(o);

      if (def.state !== 0) {
        schedule(notify, def);
      }

      return o.promise;
    };

    this["catch"] = function $catch$(failure) {
      return this.then(void 0, failure);
    };

    try {
      executor.call(void 0, function publicResolve(msg) {
        resolve.call(def, msg);
      }, function publicReject(msg) {
        reject.call(def, msg);
      });
    } catch (err) {
      reject.call(def, err);
    }
  }

  var PromisePrototype = builtInProp({}, "constructor", Promise,
  /*configurable=*/
  false); // Note: Android 4 cannot use `Object.defineProperty(..)` here

  Promise.prototype = PromisePrototype; // built-in "brand" to signal an "uninitialized" promise

  builtInProp(PromisePrototype, "__NPO__", 0,
  /*configurable=*/
  false);
  builtInProp(Promise, "resolve", function Promise$resolve(msg) {
    var Constructor = this; // spec mandated checks
    // note: best "isPromise" check that's practical for now

    if (msg && _typeof(msg) == "object" && msg.__NPO__ === 1) {
      return msg;
    }

    return new Constructor(function executor(resolve, reject) {
      if (typeof resolve != "function" || typeof reject != "function") {
        throw TypeError("Not a function");
      }

      resolve(msg);
    });
  });
  builtInProp(Promise, "reject", function Promise$reject(msg) {
    return new this(function executor(resolve, reject) {
      if (typeof resolve != "function" || typeof reject != "function") {
        throw TypeError("Not a function");
      }

      reject(msg);
    });
  });
  builtInProp(Promise, "all", function Promise$all(arr) {
    var Constructor = this; // spec mandated checks

    if (ToString.call(arr) != "[object Array]") {
      return Constructor.reject(TypeError("Not an array"));
    }

    if (arr.length === 0) {
      return Constructor.resolve([]);
    }

    return new Constructor(function executor(resolve, reject) {
      if (typeof resolve != "function" || typeof reject != "function") {
        throw TypeError("Not a function");
      }

      var len = arr.length,
          msgs = Array(len),
          count = 0;
      iteratePromises(Constructor, arr, function resolver(idx, msg) {
        msgs[idx] = msg;

        if (++count === len) {
          resolve(msgs);
        }
      }, reject);
    });
  });
  builtInProp(Promise, "race", function Promise$race(arr) {
    var Constructor = this; // spec mandated checks

    if (ToString.call(arr) != "[object Array]") {
      return Constructor.reject(TypeError("Not an array"));
    }

    return new Constructor(function executor(resolve, reject) {
      if (typeof resolve != "function" || typeof reject != "function") {
        throw TypeError("Not a function");
      }

      iteratePromises(Constructor, arr, function resolver(idx, msg) {
        resolve(msg);
      }, reject);
    });
  });
  return Promise;
});

}).call(this,typeof global !== "undefined" ? global : typeof self !== "undefined" ? self : typeof window !== "undefined" ? window : {},require("timers").setImmediate)

},{"timers":14}],13:[function(require,module,exports){
"use strict";

// shim for using process in browser
var process = module.exports = {}; // cached from whatever global is present so that test runners that stub it
// don't break things.  But we need to wrap it in a try catch in case it is
// wrapped in strict mode code which doesn't define any globals.  It's inside a
// function because try/catches deoptimize in certain engines.

var cachedSetTimeout;
var cachedClearTimeout;

function defaultSetTimout() {
  throw new Error('setTimeout has not been defined');
}

function defaultClearTimeout() {
  throw new Error('clearTimeout has not been defined');
}

(function () {
  try {
    if (typeof setTimeout === 'function') {
      cachedSetTimeout = setTimeout;
    } else {
      cachedSetTimeout = defaultSetTimout;
    }
  } catch (e) {
    cachedSetTimeout = defaultSetTimout;
  }

  try {
    if (typeof clearTimeout === 'function') {
      cachedClearTimeout = clearTimeout;
    } else {
      cachedClearTimeout = defaultClearTimeout;
    }
  } catch (e) {
    cachedClearTimeout = defaultClearTimeout;
  }
})();

function runTimeout(fun) {
  if (cachedSetTimeout === setTimeout) {
    //normal enviroments in sane situations
    return setTimeout(fun, 0);
  } // if setTimeout wasn't available but was latter defined


  if ((cachedSetTimeout === defaultSetTimout || !cachedSetTimeout) && setTimeout) {
    cachedSetTimeout = setTimeout;
    return setTimeout(fun, 0);
  }

  try {
    // when when somebody has screwed with setTimeout but no I.E. maddness
    return cachedSetTimeout(fun, 0);
  } catch (e) {
    try {
      // When we are in I.E. but the script has been evaled so I.E. doesn't trust the global object when called normally
      return cachedSetTimeout.call(null, fun, 0);
    } catch (e) {
      // same as above but when it's a version of I.E. that must have the global object for 'this', hopfully our context correct otherwise it will throw a global error
      return cachedSetTimeout.call(this, fun, 0);
    }
  }
}

function runClearTimeout(marker) {
  if (cachedClearTimeout === clearTimeout) {
    //normal enviroments in sane situations
    return clearTimeout(marker);
  } // if clearTimeout wasn't available but was latter defined


  if ((cachedClearTimeout === defaultClearTimeout || !cachedClearTimeout) && clearTimeout) {
    cachedClearTimeout = clearTimeout;
    return clearTimeout(marker);
  }

  try {
    // when when somebody has screwed with setTimeout but no I.E. maddness
    return cachedClearTimeout(marker);
  } catch (e) {
    try {
      // When we are in I.E. but the script has been evaled so I.E. doesn't  trust the global object when called normally
      return cachedClearTimeout.call(null, marker);
    } catch (e) {
      // same as above but when it's a version of I.E. that must have the global object for 'this', hopfully our context correct otherwise it will throw a global error.
      // Some versions of I.E. have different rules for clearTimeout vs setTimeout
      return cachedClearTimeout.call(this, marker);
    }
  }
}

var queue = [];
var draining = false;
var currentQueue;
var queueIndex = -1;

function cleanUpNextTick() {
  if (!draining || !currentQueue) {
    return;
  }

  draining = false;

  if (currentQueue.length) {
    queue = currentQueue.concat(queue);
  } else {
    queueIndex = -1;
  }

  if (queue.length) {
    drainQueue();
  }
}

function drainQueue() {
  if (draining) {
    return;
  }

  var timeout = runTimeout(cleanUpNextTick);
  draining = true;
  var len = queue.length;

  while (len) {
    currentQueue = queue;
    queue = [];

    while (++queueIndex < len) {
      if (currentQueue) {
        currentQueue[queueIndex].run();
      }
    }

    queueIndex = -1;
    len = queue.length;
  }

  currentQueue = null;
  draining = false;
  runClearTimeout(timeout);
}

process.nextTick = function (fun) {
  var args = new Array(arguments.length - 1);

  if (arguments.length > 1) {
    for (var i = 1; i < arguments.length; i++) {
      args[i - 1] = arguments[i];
    }
  }

  queue.push(new Item(fun, args));

  if (queue.length === 1 && !draining) {
    runTimeout(drainQueue);
  }
}; // v8 likes predictible objects


function Item(fun, array) {
  this.fun = fun;
  this.array = array;
}

Item.prototype.run = function () {
  this.fun.apply(null, this.array);
};

process.title = 'browser';
process.browser = true;
process.env = {};
process.argv = [];
process.version = ''; // empty string to avoid regexp issues

process.versions = {};

function noop() {}

process.on = noop;
process.addListener = noop;
process.once = noop;
process.off = noop;
process.removeListener = noop;
process.removeAllListeners = noop;
process.emit = noop;
process.prependListener = noop;
process.prependOnceListener = noop;

process.listeners = function (name) {
  return [];
};

process.binding = function (name) {
  throw new Error('process.binding is not supported');
};

process.cwd = function () {
  return '/';
};

process.chdir = function (dir) {
  throw new Error('process.chdir is not supported');
};

process.umask = function () {
  return 0;
};

},{}],14:[function(require,module,exports){
(function (setImmediate,clearImmediate){
"use strict";

var nextTick = require('process/browser.js').nextTick;

var apply = Function.prototype.apply;
var slice = Array.prototype.slice;
var immediateIds = {};
var nextImmediateId = 0; // DOM APIs, for completeness

exports.setTimeout = function () {
  return new Timeout(apply.call(setTimeout, window, arguments), clearTimeout);
};

exports.setInterval = function () {
  return new Timeout(apply.call(setInterval, window, arguments), clearInterval);
};

exports.clearTimeout = exports.clearInterval = function (timeout) {
  timeout.close();
};

function Timeout(id, clearFn) {
  this._id = id;
  this._clearFn = clearFn;
}

Timeout.prototype.unref = Timeout.prototype.ref = function () {};

Timeout.prototype.close = function () {
  this._clearFn.call(window, this._id);
}; // Does not start the time, just sets up the members needed.


exports.enroll = function (item, msecs) {
  clearTimeout(item._idleTimeoutId);
  item._idleTimeout = msecs;
};

exports.unenroll = function (item) {
  clearTimeout(item._idleTimeoutId);
  item._idleTimeout = -1;
};

exports._unrefActive = exports.active = function (item) {
  clearTimeout(item._idleTimeoutId);
  var msecs = item._idleTimeout;

  if (msecs >= 0) {
    item._idleTimeoutId = setTimeout(function onTimeout() {
      if (item._onTimeout) item._onTimeout();
    }, msecs);
  }
}; // That's not how node.js implements it but the exposed api is the same.


exports.setImmediate = typeof setImmediate === "function" ? setImmediate : function (fn) {
  var id = nextImmediateId++;
  var args = arguments.length < 2 ? false : slice.call(arguments, 1);
  immediateIds[id] = true;
  nextTick(function onNextTick() {
    if (immediateIds[id]) {
      // fn.call() is faster so we optimize for the common use-case
      // @see http://jsperf.com/call-apply-segu
      if (args) {
        fn.apply(null, args);
      } else {
        fn.call(null);
      } // Prevent ids from leaking


      exports.clearImmediate(id);
    }
  });
  return id;
};
exports.clearImmediate = typeof clearImmediate === "function" ? clearImmediate : function (id) {
  delete immediateIds[id];
};

}).call(this,require("timers").setImmediate,require("timers").clearImmediate)

},{"process/browser.js":13,"timers":14}],15:[function(require,module,exports){
"use strict";

/**
 * Convert array of 16 byte values to UUID string format of the form:
 * XXXXXXXX-XXXX-XXXX-XXXX-XXXXXXXXXXXX
 */
var byteToHex = [];

for (var i = 0; i < 256; ++i) {
  byteToHex[i] = (i + 0x100).toString(16).substr(1);
}

function bytesToUuid(buf, offset) {
  var i = offset || 0;
  var bth = byteToHex; // join used to fix memory issue caused by concatenation: https://bugs.chromium.org/p/v8/issues/detail?id=3175#c4

  return [bth[buf[i++]], bth[buf[i++]], bth[buf[i++]], bth[buf[i++]], '-', bth[buf[i++]], bth[buf[i++]], '-', bth[buf[i++]], bth[buf[i++]], '-', bth[buf[i++]], bth[buf[i++]], '-', bth[buf[i++]], bth[buf[i++]], bth[buf[i++]], bth[buf[i++]], bth[buf[i++]], bth[buf[i++]]].join('');
}

module.exports = bytesToUuid;

},{}],16:[function(require,module,exports){
"use strict";

// Unique ID creation requires a high quality random # generator.  In the
// browser this is a little complicated due to unknown quality of Math.random()
// and inconsistent support for the `crypto` API.  We do the best we can via
// feature-detection
// getRandomValues needs to be invoked in a context where "this" is a Crypto
// implementation. Also, find the complete implementation of crypto on IE11.
var getRandomValues = typeof crypto != 'undefined' && crypto.getRandomValues && crypto.getRandomValues.bind(crypto) || typeof msCrypto != 'undefined' && typeof window.msCrypto.getRandomValues == 'function' && msCrypto.getRandomValues.bind(msCrypto);

if (getRandomValues) {
  // WHATWG crypto RNG - http://wiki.whatwg.org/wiki/Crypto
  var rnds8 = new Uint8Array(16); // eslint-disable-line no-undef

  module.exports = function whatwgRNG() {
    getRandomValues(rnds8);
    return rnds8;
  };
} else {
  // Math.random()-based (RNG)
  //
  // If all else fails, use Math.random().  It's fast, but is of unspecified
  // quality.
  var rnds = new Array(16);

  module.exports = function mathRNG() {
    for (var i = 0, r; i < 16; i++) {
      if ((i & 0x03) === 0) r = Math.random() * 0x100000000;
      rnds[i] = r >>> ((i & 0x03) << 3) & 0xff;
    }

    return rnds;
  };
}

},{}],17:[function(require,module,exports){
"use strict";

var rng = require('./lib/rng');

var bytesToUuid = require('./lib/bytesToUuid');

function v4(options, buf, offset) {
  var i = buf && offset || 0;

  if (typeof options == 'string') {
    buf = options === 'binary' ? new Array(16) : null;
    options = null;
  }

  options = options || {};
  var rnds = options.random || (options.rng || rng)(); // Per 4.4, set bits for version and `clock_seq_hi_and_reserved`

  rnds[6] = rnds[6] & 0x0f | 0x40;
  rnds[8] = rnds[8] & 0x3f | 0x80; // Copy bytes to buffer, if provided

  if (buf) {
    for (var ii = 0; ii < 16; ++ii) {
      buf[i + ii] = rnds[ii];
    }
  }

  return buf || bytesToUuid(rnds);
}

module.exports = v4;

},{"./lib/bytesToUuid":15,"./lib/rng":16}],18:[function(require,module,exports){
module.exports={
  "name": "@realeyes/environment-checker",
  "version": "3.1.18",
  "scripts": {
    "test-unit": "karma start ./karma.conf.unit.js",
    "test": "npm run test-unit",
    "combine-coverage-unit": "istanbul-combine -d dist/coverage/unit/combined -p summary -r clover -r html -r json dist/coverage/unit/**/coverage.json",
    "combine-coverage": "npm run combine-coverage-unit",
    "check-coverage-unit": "istanbul check dist/coverage/unit/combined/coverage-final.json --statements 80 --functions 80 --branches 80 --lines 80",
    "check-coverage": "npm run check-coverage-unit",
    "lint": "eslint .",
    "build": "babel index.js | browserify - -d -t [ babelify --presets [ @babel/preset-env ] --global=true ] | exorcist ./dist/Realeyesit.EnvironmentalDetectionAPI.js.map > ./dist/Realeyesit.EnvironmentalDetectionAPI.js",
    "copy": "copyfiles -f node_modules/@realeyes/environment-detector/dist/log.gif dist",
    "copy:example": "copyfiles -f example/* dist",
    "minify": "uglifyjs --comments /^!/ dist/Realeyesit.EnvironmentalDetectionAPI.js -c -m --source-map filename='dist/Realeyesit.EnvironmentalDetectionAPI.min.js.map',url='dist/Realeyesit.EnvironmentalDetectionAPI.js.map' --output dist/Realeyesit.EnvironmentalDetectionAPI.min.js",
    "cleanup": "rimraf dist/*",
    "all": "npm run cleanup && npm run lint && npm run build && npm run copy && npm run copy:example && npm run minify"
  },
  "license": "Apache-2.0",
  "repository": {
    "type": "git",
    "url": "git+ssh://git@github.com/Realeyes/environment-checker.git"
  },
  "main": "lib/index.js",
  "devDependencies": {
    "@babel/core": "^7.4.0",
    "@babel/plugin-transform-classes": "^7.4.0",
    "@babel/plugin-transform-destructuring": "^7.4.0",
    "@babel/plugin-transform-member-expression-literals": "^7.2.0",
    "@babel/plugin-transform-modules-commonjs": "^7.4.0",
    "@babel/plugin-transform-property-literals": "^7.2.0",
    "@babel/plugin-transform-runtime": "^7.4.0",
    "@babel/plugin-transform-spread": "^7.2.2",
    "@babel/preset-env": "^7.4.2",
    "babel-eslint": "10.0.1",
    "babel-plugin-inline-replace-variables": "^1.3.1",
    "babel-plugin-istanbul": "^5.1.1",
    "babelify": "^10.0.0",
    "browserify": "^16.2.3",
    "copyfiles": "^2.1.0",
    "es6-object-assign": "^1.1.0",
    "eslint": "^5.15.3",
    "eslint-plugin-import": "^2.16.0",
    "exorcist": "^1.0.1",
    "istanbul": "^0.4.5",
    "istanbul-combine": "github:realeyes/istanbul-combine#f16c12aaaaa8039f61386bb2f34ef0aed5799104",
    "jasmine-core": "^3.3.0",
    "karma": "^4.0.1",
    "karma-bamboo-reporter": "^0.1.2",
    "karma-browserify": "^6.0.0",
    "karma-chrome-launcher": "^2.2.0",
    "karma-coverage": "^1.1.2",
    "karma-firefox-launcher": "^1.1.0",
    "karma-jasmine": "^2.0.1",
    "karma-phantomjs-launcher": "^1.0.4",
    "karma-selenium-webdriver-launcher": "^0.0.4",
    "karma-spec-reporter": "^0.0.32",
    "rimraf": "^2.6.3",
    "selenium-webdriver": "^4.0.0-alpha.1",
    "uglify-js": "^3.5.1",
    "watchify": "^3.11.1"
  },
  "description": "Environment Checker",
  "bugs": {
    "url": "https://github.com/Realeyes/environment-checker/issues"
  },
  "homepage": "https://github.com/Realeyes/environment-checker#readme",
  "directories": {
    "example": "example"
  },
  "keywords": [
    "browser",
    "environment",
    "checker"
  ],
  "dependencies": {
    "@babel/cli": "^7.2.3",
    "@realeyes/environment-detector": "^2.0.24",
    "babel-plugin-add-header-comment": "^1.0.3",
    "uuid": "^3.3.2"
  },
  "browserify": {
    "transform": [
      [
        "babelify"
      ]
    ]
  }
}

},{}]},{},[1])
//# sourceMappingURL=Realeyesit.EnvironmentalDetectionAPI.js.map
